#include "pitches.h"
#include <avr/interrupt.h>
#include <avr/sleep.h>

// constants:
#define LedPin             13                  // LED to show the action of a interrupt
#define PinOutSpeaker       8                  // Speaker and 100 Ohm resistor in series to GND.
#define wakePin             2                  // active LOW, ground this pin momentary to wake up
#define selectPin           4                  // select new program

// Variables:
int sleepStatus  = 0;                          // variable to store a request for sleep
int ProgValue;
int maxProgValue = 5;

void setup()
{
  pinMode(LedPin, OUTPUT);                     // LED for indicating a wake up
  pinMode(wakePin, INPUT_PULLUP);              // Select Pull Up Resistor
  pinMode(selectPin, INPUT_PULLUP);            // Select Pull Up Resistor
  attachInterrupt(0, wakeUpNow, LOW);          // use interrupt 0 (pin 2) and run function when gets LOW 
  digitalWrite(LedPin, HIGH);                  // sets the LED on
  delay(1000);                                 // waits for a second
  digitalWrite(LedPin, LOW);                   // sets the LED off
  ProgValue = 4;
}

void loop()
{
  if((digitalRead(selectPin)) == 0) {
    ProgValue = ProgValue+1;
    if(ProgValue >= maxProgValue) {
      ProgValue = 0;
    }
  }

  switch (ProgValue) {
  case 1:
    //do something when var equals 1
    Fanfare();                   // the melody plays
    Fanfare();                   // the melody plays twice
    break; 
  case 2:
    //do something when var equals 2
    HappyBirthDay();             // the melody plays
    HappyBirthDay();             // the melody plays twice
    break;
  case 3:
    //do something when var equals 2
    WeddingMarch();              // the melody plays
    WeddingMarch();              // the melody plays twice
    break;
  case 4:
    //do something when var equals 2
    AllMyDucks();                 // the melody plays
    AllMyDucks();                 // the melody plays twice
    break;
  default: 
    YankyDoodle();                 // the melody plays
    // if nothing else matches, do the default
    // default is optional
  }   

  delay(1000);                                 // waits for a second
  sleepStatus = digitalRead(wakePin);          // read sleep pin here.
  if (sleepStatus == HIGH) {                   // start to put the device in sleep
    sleepNow();                                // sleep function called here
  }
}
